'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var datasetShim = function datasetShim(element) {
  if (!element.hasAttributes()) return;
  var dataset = {};
  var attrs = Array.from(element.attributes);
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = attrs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var attr = _step.value;
      var name = attr.name;
      var value = attr.value;

      if (!name.startsWith('data-')) continue;
      var key = name.split('data-').filter(function (x, i) {
        return i > 0;
      }).map(function (word, i) {
        return i === 0 ? word : word.map(function (letter, position) {
          return position === 0 ? letter.toUpperCase() : letter.toLowerCase();
        });
      });
      dataset[key] = value;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return dataset;
};

/**
 *
 * @param  {[type]} ReactElement [description]
 * @return {[type]}              [description]
 */
var ReactDOMInject = function ReactDOMInject(ReactElement) {
  return render = function render(selector) {
    var props = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    var element = document.querySelector(id);
    if (!element) {
      console.warn('ReactHTML: No element found with \'' + id + '\' id');
      return;
    }
    var dataset = element.dataset;
    if (!dataset) dataset = datasetShim(element);
    var combinedProps = dataset ? Object.assign(props, dataset) : props;
    var __html = element.innerHTML.length > 0 ? element.innerHTML : null;
    return _reactDom2.default.render(__html ? _react2.default.createElement(ReactElement, _extends({}, combinedProps, { dangerouslySetInnerHTML: { __html: __html } })) : _react2.default.createElement(ReactElement, combinedProps), element);
  };
};

exports.default = ReactHTML;